#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

extern int Dee_period = 48;
extern double Dee_change = 3.0;
int G_ma_method_88 = MODE_LWMA;
int G_applied_price_92 = PRICE_CLOSE;
extern int SL_distance_pips = 16;
extern bool Email = TRUE;
double G_ibuf_104[];
double G_ibuf_108[];
double G_ibuf_112[];
datetime G_time_116;

// 9B1AEE847CFB597942D106A4135D4FE6
void f0_1(string As_0, double Ad_8, double Ad_16, double Ad_24) {
   string Ls_32;
   string Ls_40;
   string Ls_48;
   string Ls_56;
   string Ls_64;
   if (Time[0] != G_time_116) {
      G_time_116 = Time[0];
      if (Ad_24 != 0.0) Ls_48 = " at price " + DoubleToStr(Ad_24, 4);
      else Ls_48 = "";
      if (Ad_8 != 0.0) Ls_40 = ", TakeProfit on " + DoubleToStr(Ad_8, 4);
      else Ls_40 = "";
      if (Ad_16 != 0.0) Ls_32 = ", StopLoss on " + DoubleToStr(Ad_16, 4);
      else Ls_32 = "";
      Alert("SkyWalkerGreenRed " + As_0 + Ls_48 + Ls_40 + Ls_32 + " ", Symbol(), ", ", Period(), " minutes chart");
      Ls_56 = "Alert " + As_0 + Ls_48;
      Ls_64 = "Alert " + As_0 + Ls_48 + Ls_40 + Ls_32 + " " + Symbol() + ", " + Period() + " minutes chart";
      if (Email) SendMail(Ls_56, Ls_64);
   }
}

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   string Lsa_0[256];
   int Li_12;
   for (int index_4 = 0; index_4 < 256; index_4++) Lsa_0[index_4] = CharToStr(index_4);
   int str2int_8 = StrToInteger(Lsa_0[67] + Lsa_0[111] + Lsa_0[112] + Lsa_0[121] + Lsa_0[32] + Lsa_0[82] + Lsa_0[105] + Lsa_0[103] + Lsa_0[104] + Lsa_0[116] + Lsa_0[32] +
      Lsa_0[169] + Lsa_0[32] + Lsa_0[75] + Lsa_0[97] + Lsa_0[122] + Lsa_0[97] + Lsa_0[111] + Lsa_0[111] + Lsa_0[32] + Lsa_0[50] + Lsa_0[48] + Lsa_0[49] + Lsa_0[49] + Lsa_0[32]);
   if (Dee_period == 8) Li_12 = 2;
   else Li_12 = 4;
   IndicatorBuffers(3);
   string Ls_16 = "(" + Dee_period + ")";
   SetIndexBuffer(0, G_ibuf_104);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, Li_12);
   SetIndexLabel(0, "SkyWalkerGreenRed ");
   SetIndexBuffer(1, G_ibuf_108);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, Li_12);
   SetIndexLabel(1, "SkyWalkerGreenRed ");
   SetIndexBuffer(2, G_ibuf_112);
   ArraySetAsSeries(G_ibuf_112, TRUE);
   IndicatorShortName("SkyWalkerGreenRed(" + Dee_period + ")");
   IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS) + 1.0);
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   return (0);
}

// 945D754CB0DC06D04243FCBA25FC0802
double f0_0(int Ai_0, int A_period_4) {
   return (iMA(NULL, 0, A_period_4, 0, G_ma_method_88, G_applied_price_92, Ai_0));
}

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double Lda_0[];
   double Lda_4[];
   double Ld_8;
   int ind_counted_16 = IndicatorCounted();
   if (ind_counted_16 < 0) return (-1);
   int Li_20 = 1;
   int period_24 = MathFloor(MathSqrt(Dee_period));
   int Li_28 = MathFloor(Dee_period / Dee_change);
   int Li_32 = Bars - ind_counted_16 + Dee_period;
   if (Li_32 > Bars) Li_32 = Bars;
   ArraySetAsSeries(Lda_0, TRUE);
   ArrayResize(Lda_0, Li_32);
   ArraySetAsSeries(Lda_4, TRUE);
   ArrayResize(Lda_4, Li_32);
   double Ld_36 = Close[1];
   for (Li_20 = 0; Li_20 < Li_32; Li_20++) Lda_0[Li_20] = 2.0 * f0_0(Li_20, Li_28) - f0_0(Li_20, Dee_period);
   for (Li_20 = 0; Li_20 < Li_32 - Dee_period; Li_20++) G_ibuf_112[Li_20] = iMAOnArray(Lda_0, 0, period_24, 0, G_ma_method_88, Li_20);
   for (Li_20 = Li_32 - Dee_period; Li_20 > 0; Li_20--) {
      Lda_4[Li_20] = Lda_4[Li_20 + 1];
      if (G_ibuf_112[Li_20] > G_ibuf_112[Li_20 + 1]) Lda_4[Li_20] = 1;
      if (G_ibuf_112[Li_20] < G_ibuf_112[Li_20 + 1]) Lda_4[Li_20] = -1;
      if (Lda_4[Li_20] > 0.0) {
         G_ibuf_104[Li_20] = G_ibuf_112[Li_20];
         if (Lda_4[Li_20 + 1] < 0.0) G_ibuf_104[Li_20 + 1] = G_ibuf_112[Li_20 + 1];
         if (Lda_4[Li_20 + 1] < 0.0) {
            if (Li_20 == 1) {
               Ld_8 = Ld_36 - SL_distance_pips * Point;
               f0_1("Buy signal", 0, Ld_8, Ld_36);
            }
         }
         G_ibuf_108[Li_20] = EMPTY_VALUE;
      } else {
         if (Lda_4[Li_20] < 0.0) {
            G_ibuf_108[Li_20] = G_ibuf_112[Li_20];
            if (Lda_4[Li_20 + 1] > 0.0) G_ibuf_108[Li_20 + 1] = G_ibuf_112[Li_20 + 1];
            if (Lda_4[Li_20 + 1] > 0.0) {
               if (Li_20 == 1) {
                  Ld_8 = Ld_36 + SL_distance_pips * Point;
                  f0_1("Sell signal", 0, Ld_8, Ld_36);
               }
            }
            G_ibuf_104[Li_20] = EMPTY_VALUE;
         }
      }
   }
   return (0);
}
